Index: Daodan/src/Oni_Symbols.h
===================================================================
--- Daodan/src/Oni_Symbols.h	(revision 691)
+++ Daodan/src/Oni_Symbols.h	(revision 692)
@@ -1,8 +1,8 @@
 #ifndef ONI_SYMBOLS_H 
 #define ONI_SYMBOLS_H
-#include "bool.h"
+#include "stdint.h"
 #include <stdio.h>
 #include "Oni.h"
-#include "oni_gl.h"
+#include "Oni_GL.h"
 #include "Oni_Character.h"
 #include "BFW_ScriptLang.h"
@@ -41,8 +41,8 @@
 #define gl_gamma_ramp_valid	(*((int*)0x005603fc))
 
-// OpenGL whatev?
+// OpenGL: list of pointers to opengl32.dll functions (and a few functions from GL extensions)
 #define gl_api				(*((gl_api_t**)0x00560604))
 
-// OpenGL whatev?
+// OpenGL render engine descriptor (resolutions, flags, context methods)
 #define gl_eng				(*((gl_engine_t**)0x00560600))
 
@@ -107,41 +107,77 @@
 DefFunc(int, gl_platform_initialize, ONICALL, (), 0x00407da0);
 
+// Retrieve gamma value from settings
 DefFunc(float, ONrPersist_GetGamma, ONICALL, (), 0x0050f450);
+
+// Retrieve if the game was completed
 DefFunc(uint8_t, ONrPersist_GetWonGame, ONICALL, (), 0x0050f660);
 
+// Print a message to the startup.txt log
 DefFunc(void, UUrStartupMessage, __cdecl, (const char* fmt, ...), 0x00424860);
+
+// Probably to spawn a new character
 DefFunc(int16_t, ONrGameState_NewCharacter, ONICALL, (void* CHAR, void* AISA, void* flag, uint32_t* list_location), 0x004dac50);
+
+// Remove character
+DefFunc(void, ONrGameState_DeleteCharacter, ONICALL, (Character *inCharacter), 0x004DC480);
+
+DefFunc(void, ONrGameState_Timer_Start, ONICALL, (char* function, int time), 0x004FD370);
+
+// Get active (player?) character
 DefFunc(ActiveCharacter*, ONrGetActiveCharacter, ONICALL, (void* CharacterPtr), 0x004f1180);
+
+DefFunc(uint32_t, ONrCharacter_GetHealthShade, ONICALL, (uint32_t health, uint32_t maxhealth), 0x004EF450);
 DefFunc(void, ONrCharacter_NewAnimationHook, ONICALL, (Character *ioCharacter, ActiveCharacter *ioActiveCharacter), 0x004E97A0);
 DefFunc(void, ONrCharacter_SetAnimationExternal, ONICALL, (Character *ioCharacter, short state, void* animation, int interpolation), 0x004EB340);
-
+DefFunc(void, ONrCharacter_SetHitPoints, ONICALL, (Character *ioCharacter, uint32_t inHitPoints), 0x004EB220);
+DefFunc(void, ONrCharacter_SetCharacterClass, ONICALL, (Character* Char, ONCC* Class), 0x004D7C30);
+DefFunc(void, ONrCorpse_Create, ONICALL, (Character* Character), 0x004EF340);
+
+
+// Print message to console
 DefFunc(void, COrTextArea_Print, ONICALL, (uint32_t area, uint32_t priority, uint32_t textshade, uint32_t textshadowshade, const char* text, uint32_t unk_alwaws_0, uint32_t fadetime), 0x00431340);
+
+// Original cheat function
 DefFunc(uint8_t, ONrCheater, ONICALL, (uint32_t cheat), 0x004f5c30);
+
+// ?
 DefFunc(int, AUrMessageBox, __cdecl, (int Buttons, char *Message, ...), 0x004378c0);
 DefFunc(char*, SSrMessage_Find, ONICALL, (char* message_key), 0x0047F550);
 DefFunc(void, ONiGameState_FindAutoPromptMessage, ONICALL, (char* Note, void* ptr), 0x004FDBE0);
 
+// Register a BSL function with a return type
 DefFunc(uint16_t, SLrScript_Command_Register_ReturnType, ONICALL, (char* name, char* desc, char* argfmt, sl_type type, sl_func callback), 0x00477b20);
+
+// Register a BSL function without a return value
 DefFunc(uint16_t, SLrScript_Command_Register_Void, ONICALL, (char* name, char* desc, char* argfmt, sl_func callback), 0x00477b40);
+
+// Register a global BSL variable
 DefFunc(uint16_t, SLrGlobalVariable_Register_Int32, ONICALL, (char* name, char* desc, int32_t* data), 0x00477e30);
 DefFunc(uint16_t, SLrGlobalVariable_Register_Float, ONICALL, (char* name, char* desc, float* data), 0x00477ec0);
 DefFunc(uint16_t, SLrGlobalVariable_Register_String, ONICALL, (char* name, char* desc, char* data), 0x00477fe0);
 
+// Print message to console ?
 DefFunc(int, COrMessage_Print, ONICALL, (char* Message, char* Key, void* noidea), 0x004304B0);
+
 DefFunc(void, COrConsole_StatusLine_Display, ONICALL, (), 0x00431E70);
+
+// Get pointer to specified data instance
 DefFunc(int16_t, TMrInstance_GetDataPtr, ONICALL, (int tag, char* name, void* pointer), 0x004232E0);
+
+// Get name of data instance pointed to
 DefFunc(char*, TMrInstance_GetInstanceName, ONICALL, (void* InstancePointer), 0x00423D90);
 
+DefFunc(short, TMrInstance_GetDataPtr_ByNumber, ONICALL, (int tag, int number, void** out), 0x00423680);
+DefFunc(uint32_t, TMrInstance_GetTagCount, ONICALL, (int tag), 0x004236F0);
+
+// Draw text on the screen
 DefFunc(int16_t, TSrContext_DrawText, ONICALL, (uint32_t TSrContext, char* Text, char alpha, uint32_t usuallyzero, void* pRect), 0x0042DF00);
 DefFunc(int16_t, TSrContext_New, ONICALL, (void* FontInstance, int size, int hthsik1,int hthsik2,int hthsik3, void* TSrContext), 0x0042EA30);
 
 DefFunc(int16_t, TSrContext_SetShade, ONICALL, (void *ioTextContext, uint32_t inShade), 0x0042EE50);
-DefFunc(void, ONrGameState_Timer_Start, ONICALL, (char* function, int time), 0x004FD370);
+
 DefFunc(uint16_t, TRrAnimation_GetDuration, ONICALL, (void* Animation), 0x00428740);
 DefFunc(uint16_t, TRrAnimation_GetTo, ONICALL, (void* Animation), 0x00428730);
 DefFunc(uint16_t, TRrAnimation_GetFrom, ONICALL, (void* Animation), 0x00428720);
-
-DefFunc(void, ONrCharacter_SetHitPoints, ONICALL, (Character *ioCharacter, uint32_t inHitPoints), 0x004EB220);
-DefFunc(void, ONrCorpse_Create, ONICALL, (Character* Character), 0x004EF340);
 
 DefFunc(uint16_t, iSetCharacterClass, ONICALL, (sl_callinfo* callinfo, uint32_t numargs, sl_arg args[], int* dontuse1, int* dontuse2, sl_arg* ret), 0x004D99D0);
@@ -150,6 +186,4 @@
 //NOT USED: DefFunc(int, OBJiObjectGroup_GetNumObjects, ONICALL, (void *inObjectGroup), );
 
-DefFunc(void, ONrGameState_DeleteCharacter, ONICALL, (Character *inCharacter), 0x004DC480);
-
 DefFunc(int, OBJrObjectType_EnumerateObjects, ONICALL, (int inObjectType, OBJtEnumCallback_Object inEnumCallback, int inUserData), 0x004D0080);
 
@@ -160,8 +194,4 @@
 
 
-DefFunc(void, ONrCharacter_SetCharacterClass, ONICALL, (Character* Char, ONCC* Class), 0x004D7C30);
-DefFunc(short, TMrInstance_GetDataPtr_ByNumber, ONICALL, (int tag, int number, void** out), 0x00423680);
-DefFunc(uint32_t, TMrInstance_GetTagCount, ONICALL, (int tag), 0x004236F0);
-DefFunc(uint32_t, ONrCharacter_GetHealthShade, ONICALL, (uint32_t health, uint32_t maxhealth), 0x004EF450);
 DefFunc(void, ONiDrawWeaponSight, ONICALL, (Character* Char), 0x004E1900);
 DefFunc(void, AI2rDisplayDebuggingInfo, ONICALL, (Character* Char), 0x0048C5F0);