Index: Daodan/src/binkw32.def
===================================================================
--- Daodan/src/binkw32.def	(revision 687)
+++ Daodan/src/binkw32.def	(revision 990)
@@ -2,88 +2,22 @@
 
 EXPORTS
+	_BinkBufferBlit@12	@1
+	_BinkBufferClose@4	@4
+	_BinkBufferLock@4	@7
+	_BinkBufferOpen@16	@8
+	_BinkBufferSetOffset@12	@11
+	_BinkBufferUnlock@4	@14
+	_BinkClose@4	@16
+	_BinkCopyToBuffer@28	@18
+	_BinkDoFrame@4	@20
+	_BinkGetRects@8	@24
+	_BinkNextFrame@4	@33
+	_BinkOpen@8	@34
+	_BinkOpenDirectSound@4	@35
+	_BinkService@4	@41
+	_BinkSetIOSize@4	@45
+	_BinkSetSoundOnOff@8	@48
+	_BinkSetSoundSystem@8	@49
+	_BinkSetVolume@8	@52
+	_BinkWait@4	@53
 
-        _BinkBufferBlit@12          = REALBINK._BinkBufferBlit@12          @1
-	_BinkBufferCheckWinPos@12   = REALBINK._BinkBufferCheckWinPos@12   @2
-	_BinkBufferClear@8          = REALBINK._BinkBufferClear@8          @3
-	_BinkBufferClose@4          = REALBINK._BinkBufferClose@4          @4
-	_BinkBufferGetDescription@4 = REALBINK._BinkBufferGetDescription@4 @5
-	_BinkBufferGetError@0       = REALBINK._BinkBufferGetError@0       @6
-	_BinkBufferLock@4           = REALBINK._BinkBufferLock@4           @7
-	_BinkBufferOpen@16          = REALBINK._BinkBufferOpen@16          @8
-	_BinkBufferSetDirectDraw@8  = REALBINK._BinkBufferSetDirectDraw@8  @9
-	_BinkBufferSetHWND@8        = REALBINK._BinkBufferSetHWND@8        @10
-	_BinkBufferSetOffset@12     = REALBINK._BinkBufferSetOffset@12     @11
-	_BinkBufferSetResolution@12 = REALBINK._BinkBufferSetResolution@12 @12
-	_BinkBufferSetScale@12      = REALBINK._BinkBufferSetScale@12      @13
-	_BinkBufferUnlock@4         = REALBINK._BinkBufferUnlock@4         @14
-	_BinkCheckCursor@20         = REALBINK._BinkCheckCursor@20         @15
-	_BinkClose@4                = REALBINK._BinkClose@4                @16
-	_BinkCloseTrack@4           = REALBINK._BinkCloseTrack@4           @17
-	_BinkCopyToBuffer@28        = REALBINK._BinkCopyToBuffer@28        @18
-	_BinkDDSurfaceType@4        = REALBINK._BinkDDSurfaceType@4        @19
-	_BinkDoFrame@4              = REALBINK._BinkDoFrame@4              @20
-	_BinkGetError@0             = REALBINK._BinkGetError@0             @21
-	_BinkGetKeyFrame@12         = REALBINK._BinkGetKeyFrame@12         @22
-	_BinkGetRealtime@12         = REALBINK._BinkGetRealtime@12         @23
-	_BinkGetRects@8             = REALBINK._BinkGetRects@8             @24
-	_BinkGetSummary@8           = REALBINK._BinkGetSummary@8           @25
-	_BinkGetTrackData@8         = REALBINK._BinkGetTrackData@8         @26
-	_BinkGetTrackID@8           = REALBINK._BinkGetTrackID@8           @27
-	_BinkGetTrackMaxSize@8      = REALBINK._BinkGetTrackMaxSize@8      @28
-	_BinkGetTrackType@8         = REALBINK._BinkGetTrackType@8         @29
-	_BinkGoto@12                = REALBINK._BinkGoto@12                @30
-	_BinkIsSoftwareCursor@8     = REALBINK._BinkIsSoftwareCursor@8     @31
-	_BinkLogoAddress@0          = REALBINK._BinkLogoAddress@0          @32
-	_BinkNextFrame@4            = REALBINK._BinkNextFrame@4            @33
-	_BinkOpen@8                 = REALBINK._BinkOpen@8                 @34
-	_BinkOpenDirectSound@4      = REALBINK._BinkOpenDirectSound@4      @35
-	_BinkOpenMiles@4            = REALBINK._BinkOpenMiles@4            @36
-	_BinkOpenTrack@8            = REALBINK._BinkOpenTrack@8            @37
-	_BinkOpenWaveOut@4          = REALBINK._BinkOpenWaveOut@4          @38
-	_BinkPause@8                = REALBINK._BinkPause@8                @39
-	_BinkRestoreCursor@4        = REALBINK._BinkRestoreCursor@4        @40
-	_BinkService@4              = REALBINK._BinkService@4              @41
-	_BinkSetError@4             = REALBINK._BinkSetError@4             @42
-	_BinkSetFrameRate@8         = REALBINK._BinkSetFrameRate@8         @43
-	_BinkSetIO@4                = REALBINK._BinkSetIO@4                @44
-	_BinkSetIOSize@4            = REALBINK._BinkSetIOSize@4            @45
-	_BinkSetPan@8               = REALBINK._BinkSetPan@8               @46
-	_BinkSetSimulate@4          = REALBINK._BinkSetSimulate@4          @47
-	_BinkSetSoundOnOff@8        = REALBINK._BinkSetSoundOnOff@8        @48
-	_BinkSetSoundSystem@8       = REALBINK._BinkSetSoundSystem@8       @49
-	_BinkSetSoundTrack@4        = REALBINK._BinkSetSoundTrack@4        @50
-	_BinkSetVideoOnOff@8        = REALBINK._BinkSetVideoOnOff@8        @51
-	_BinkSetVolume@8            = REALBINK._BinkSetVolume@8            @52
-	_BinkWait@4                 = REALBINK._BinkWait@4                 @53
-	_ExpandBink@56              = REALBINK._ExpandBink@56              @54
-	_ExpandBundleSizes@8        = REALBINK._ExpandBundleSizes@8        @55
-	_RADSetMemory@8             = REALBINK._RADSetMemory@8             @56
-	_RADTimerRead@0             = REALBINK._RADTimerRead@0             @57
-	_YUV_blit_16a1bpp@52        = REALBINK._YUV_blit_16a1bpp@52        @58
-	_YUV_blit_16a1bpp_mask@52   = REALBINK._YUV_blit_16a1bpp_mask@52   @59
-	_YUV_blit_16a4bpp@52        = REALBINK._YUV_blit_16a4bpp@52        @60
-	_YUV_blit_16a4bpp_mask@52   = REALBINK._YUV_blit_16a4bpp_mask@52   @61
-	_YUV_blit_16bpp@48          = REALBINK._YUV_blit_16bpp@48          @62
-	_YUV_blit_16bpp_mask@48     = REALBINK._YUV_blit_16bpp_mask@48     @63
-	_YUV_blit_24bpp@48          = REALBINK._YUV_blit_24bpp@48          @64
-	_YUV_blit_24bpp_mask@48     = REALBINK._YUV_blit_24bpp_mask@48     @65
-	_YUV_blit_24rbpp@48         = REALBINK._YUV_blit_24rbpp@48         @66
-	_YUV_blit_24rbpp_mask@48    = REALBINK._YUV_blit_24rbpp_mask@48    @67
-	_YUV_blit_32abpp@52         = REALBINK._YUV_blit_32abpp@52         @68
-	_YUV_blit_32abpp_mask@52    = REALBINK._YUV_blit_32abpp_mask@52    @69
-	_YUV_blit_32bpp@48          = REALBINK._YUV_blit_32bpp@48          @70
-	_YUV_blit_32bpp_mask@48     = REALBINK._YUV_blit_32bpp_mask@48     @71
-	_YUV_blit_32rabpp@52        = REALBINK._YUV_blit_32rabpp@52        @72
-	_YUV_blit_32rabpp_mask@52   = REALBINK._YUV_blit_32rabpp_mask@52   @73
-	_YUV_blit_32rbpp@48         = REALBINK._YUV_blit_32rbpp@48         @74
-	_YUV_blit_32rbpp_mask@48    = REALBINK._YUV_blit_32rbpp_mask@48    @75
-	_YUV_blit_UYVY@48           = REALBINK._YUV_blit_UYVY@48           @76
-	_YUV_blit_UYVY_mask@48      = REALBINK._YUV_blit_UYVY_mask@48      @77
-	_YUV_blit_YUY2@48           = REALBINK._YUV_blit_YUY2@48           @78
-	_YUV_blit_YUY2_mask@48      = REALBINK._YUV_blit_YUY2_mask@48      @79
-	_YUV_blit_YV12@52           = REALBINK._YUV_blit_YV12@52           @80
-	_YUV_init@4                 = REALBINK._YUV_init@4                 @81
-	_radfree@4                  = REALBINK._radfree@4                  @82
-	_radmalloc@4                = REALBINK._radmalloc@4                @83
-
-